local ffi = require 'ffi'
local C = ffi.C

ffi.cdef[[
struct rlimit {
    unsigned long    rlim_cur;
    unsigned long    rlim_max;
};

enum {
    RLIMIT_CORE = 4,
};

enum {
    RLIM_INFINITY = 0xffffffff,
};

int setrlimit(int resource, const struct rlimit *rlim);
]]

local function enable_core_dump(enable)
    if enable then
        os.execute("echo '/tmp/%e-%t-core.%p' > /proc/sys/kernel/core_pattern")
        local core_limit = ffi.new('struct rlimit[1]')
        core_limit[0].rlim_cur = C.RLIM_INFINITY
        core_limit[0].rlim_max = C.RLIM_INFINITY
        assert(C.setrlimit(C.RLIMIT_CORE, core_limit) == 0,
            "Core dump not enabled")
    end
end

return enable_core_dump
