local ffi = require 'ffi'
local lj_include = require 'lj_include'

lj_include('sys_types')

ffi.cdef[[
struct iovec {
    void *iov_base;
    size_t iov_len;
};
]]

local defs = {
    UIO_MAXIOV = '1024',
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

