require 'strict'
local ev = require 'ev'

local ffi = require 'ffi'
local C = ffi.C
ffi.cdef[[
typedef int     pid_t;
pid_t   getpid();
]]


local m = {}

function m.RegisterMe(l)
    local loop = l or ev.Loop.default
    ev.Timer.new(function(l, t, e)
            local dbus = require 'dbus'
            local bus = dbus.bus_get('system')
            bus:hook_libev_default_loop()
            local master = bus:auto_proxy_wait('com.somat.armada.Master',
                '/com/somat/armada/Master')
            local name = arg[0]:gsub('.lua', '')
            master:RegisterCriticalProcess(name,
                string.format("%.0f", tonumber(C.getpid())))
        end, 1, 0):start(loop)
end

return m
